#!/usr/bin/env perl
use strict;
use warnings;
use FindBin::libs;

use Path::Class qw/dir/;

use MyIR::Index;
use MyIR::Document;

my @doc_ids;
my $dh = dir('db')->open;
while (my $doc_id = $dh->read) {
    if ($doc_id !~ m/^\d+$/) {
        next;
    }
    push @doc_ids, $doc_id;
}

# intersect()  vb code Τ˥ȤȤ
@doc_ids = sort { $a <=> $b } @doc_ids;

my $index = MyIR::Index->new;
for my $doc_id (@doc_ids) {
    my $doc = MyIR::Document->new_from_id($doc_id);
    $index->add_document($doc);
}

$index->save('test.idx');
