#!/usr/bin/env perl
use strict;
use warnings;
use FindBin::libs; # ./lib CupX

use Perl6::Say;
use Encode qw/decode/;
use Encode::Guess;
use LWP::UserAgent;
use HTML::ExtractContent;
use HTTP::Response::Encoding;

use MyIR::Document;

my $url = shift or die "usage: $0 <url>";

my $ua  = LWP::UserAgent->new;
my $res = $ua->get($url);

if ($res->is_error) {
    die $res->status_line;
}

# GR[fBO̔
my $enc = $res->encoding;
if (!$enc) {
    $enc = guess_encoding($res->content, qw/cp932 euc-jp iso-2022-jp utf8 shiftjis/);
}
my $html = decode($enc, $res->content);

my $doc = MyIR::Document->new;
$doc->url     = $url;
$doc->title   = extract_title($html);
$doc->content = extract_content($html);
$doc->save;

say $doc->doc_id;

# HTML ^Cg𔲂o
sub extract_title {
    my $html = shift;
    $html =~ qr/<title[^>]*>(.*?)<\/title\s*>/is;
    return $1;
}

# {o
sub extract_content {
    my $ext = HTML::ExtractContent->new;
    $ext->extract($html);
    return $ext->as_text;
}
