package MyIR::DocID;
use strict;
use warnings;
use Path::Class qw/file/;

sub new {
    my ($class, $file) = @_;
    my $self = bless { file => $file };
    return $self;
}

sub current {
    my $self = shift;
    if (defined $self->{current}) {
        return $self->{current};
    } else {
        my $fh = file($self->{file})->open or return 0;
        my $cur = $fh->getline;
        chomp $cur;
        $cur =~ m/^\d+$/ or die 'assert (not a number)';
        return $self->{current} = $cur;
    }
}

sub incr_id {
    my $self = shift;
    $self->{current} = $self->current + 1;
}

sub save {
    my $self = shift;
    my $fh = file($self->{file})->openw;
    $fh->print( $self->current );
    $fh->close;
}

1;
