package MyIR::Index::Compressed;
use strict;
use warnings;
use base qw/MyIR::Index/;

use Array::Gap;

sub add {
    my ($self, $w, $doc_id) = @_;
    if ($self->index->{$w}) {
        $self->index->{$w}->push($doc_id);
    } else {
        $self->index->{$w} = Array::Gap->new([ $doc_id ]);
    }
    return $doc_id;
}

sub get_postings {
    my ($self, $w) = @_;
    my $p = $self->index->{$w};
    $p ? return $p->as_array : return;
}

sub save {
    my ($self, $file) = @_;
    for my $w (keys %{$self->index}) {
        $self->index->{$w} = $self->index->{$w}->bin;
    }
    Storable::store($self, $file) or die "Can't store index: $!";
}

sub load {
    my ($class, $file) = @_;
    my $self = Storable::retrieve($file) or die "Can't retrieve index: $!";
    for my $w (keys %{$self->index}) {
        $self->index->{$w} = Array::Gap->new($self->index->{$w});
    }
    return $self;
}

1;
