#!/usr/bin/env perl
use strict;
use warnings;
use FindBin::libs;

use Perl6::Say;
use Term::Encoding qw/term_encoding/;
use Encode qw/decode/;

use MyIR::Index;

my $q = shift or die "usage: %0 <query>";

my $index = MyIR::Index->load('test.idx');

for my $doc ($index->retrieve_documents( decode(term_encoding, $q) )) {
    say sprintf "[%d] %s\n%s\n", $doc->doc_id, $doc->title, $doc->url;
}
