#!/usr/bin/env perl
use strict;
use warnings;
use utf8;
use FindBin::libs;
use Perl6::Say;

use Path::Class qw/dir/;

use MyIR::Index;
use MyIR::Document;

my @doc_ids;
my $dh = dir('db')->open;
while (my $doc_id = $dh->read) {
    if ($doc_id !~ m/^\d+$/) {
        next;
    }
    push @doc_ids, $doc_id;
}

# intersect() と vb code のためにソートしとく
@doc_ids = sort { $a <=> $b } @doc_ids;

# use Benchmark::Timer;
# my $t = Benchmark::Timer->new;
# $t->start('create index');

my $index = MyIR::Index->new;
for my $doc_id (@doc_ids) {
    my $doc = MyIR::Document->new_from_id($doc_id);
    $index->add_document($doc);
}

# $t->stop('create index');
# warn scalar $t->reports;

for my $doc ($index->retrieve_documents('naoya')) {
    say sprintf "[%d] %s", $doc->doc_id, $doc->url;
}
